routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\PaqueteController;
use App\Http\Controllers\RequerimientoController;

Route::view('/', 'website.index')->name('home');

Route::middleware(['auth:sanctum', 'verified'])->get('/dashboard', function () {
    return view('dashboard');
})->name('dashboard');

Route::group([
    'prefix' => 'admin',
    'middleware' => ['auth:sanctum', 'verified']
], function(){

    Route::get('/paquetes', [PaqueteController::class, 'index'])->name('paquetes');
    Route::get('/paquetes/{paquete}', [PaqueteController::class, 'show'])->name('paquete');
    Route::get('/nuevo-paquete', [PaqueteController::class, 'create'])->name('nuevo-paquete');
    Route::get('/', [RequerimientoController::class, 'index'])->name('requerimientos');
    Route::get('/{requerimiento}', [RequerimientoController::class, 'show'])->name('requerimiento');

});

app/Models/Paquete.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Paquete extends Model
{
    use HasFactory;

    public function productos(){
        return $this->hasMany(ProductoEnPaquete::class, 'paquete_id');
    }

    public function getFormatoDePrecioAttribute(){
        return '$' . number_format($this->precio, 2) . ' USD';
    }

}

app/Models/Requerimiento.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Requerimiento extends Model
{
    use HasFactory;

    public function paquete(){
        return $this->belongsTo(Paquete::class, 'paquete_id');
    }

    public function getNumeroAttribute(){
        return '#'.(intval($this->id) + 1000);
    }

    public function getNombreCompletoAttribute(){
        return $this->nombre .' '. $this->apellido;
    }

    public function getFechaAttribute(){
        return $this->created_at->format('d M, Y');
    }

    public function getEtapaAttribute(){
        if($this->etapa_id == 1){
            return 'Pendiente';
        }elseif($this->etapa_id == 2){
            return 'En proceso';
        }elseif($this->etapa_id == 3){
            return 'Cerrado Perdido';
        }elseif($this->etapa_id == 4){
            return 'Cerrado Ganado';
        }
    }
}

app/Http/Livewire/AgregarProductoAPaquete.php
<?php

namespace App\Http\Livewire;

use Livewire\Component;
use App\Models\Producto;
use App\Models\ProductoEnPaquete;

class AgregarProductoAPaquete extends Component
{

    public $paquete;
    public $producto_id = '';
    public $cantidad = 1;

    public $mostrar_formulario = false;

    public function mount($paquete){
        $this->paquete = $paquete;
    }

    public function render()
    {
        $productos = Producto::all();
        return view('livewire.agregar-producto-a-paquete', compact('productos'));
    }

    public function agregar_producto(){
        $this->mostrar_formulario = true;
    }

    public function cancelar(){
        $this->mostrar_formulario = false;
        $this->producto_id = '';
        $this->cantidad = 1;
    }

    public function guardar_producto_en_paquete(){
        $producto_en_paquete = new ProductoEnPaquete();
        $producto_en_paquete->paquete_id = $this->paquete->id;
        $producto_en_paquete->producto_id = $this->producto_id;
        $producto_en_paquete->cantidad = $this->cantidad;
        $producto_en_paquete->save();

        return redirect()->route('paquete', $this->paquete->id);
    }

}

app/Http/Livewire/ComentarioAlCliente.php
<?php

namespace App\Http\Livewire;

use Livewire\Component;
use Illuminate\Support\Facades\Mail;

class ComentarioAlCliente extends Component
{

    public $comentario;
    public $requerimiento;
    public $comentario_enviado = false;

    public function mount($requerimiento){
        $this->requerimiento = $requerimiento;
    }

    public function render()
    {
        return view('livewire.comentario-al-cliente');
    }

    public function enviar_correo_al_cliente(){
    
        $datos_del_correo = [

            'nombre_del_cliente' => $this->requerimiento->nombre_completo,
            'comentario' => $this->comentario

        ];

        Mail::to($this->requerimiento->email)
            ->send(new \App\Mail\ComentarioAlCliente($datos_del_correo));

        $this->comentario = '';
        $this->comentario_enviado = true;

    }

}

app/Http/Livewire/DetalleDePaquete.php
<?php

namespace App\Http\Livewire;

use App\Models\Paquete;
use App\Models\ProductoEnPaquete;
use Livewire\Component;

class DetalleDePaquete extends Component
{
    public $paquete;
    public $nombre;
    public $descripcion;
    public $especificaciones;
    public $precio;
    public $informacion_actualizada = false;
    public $metodo;

    public function getProductosProperty()
    {

        return $this->paquete->productos;

    }

    public function mount($paquete, $metodo)
    {
        $this->metodo           = $metodo;
        $this->paquete          = $paquete;
        $this->nombre           = $paquete->nombre;
        $this->descripcion      = $paquete->descripcion;
        $this->especificaciones = $paquete->especificaciones;
        $this->precio           = $paquete->precio;
    }

    public function render()
    {
        return view('livewire.detalle-de-paquete');
    }

    public function actualizar_detalles_generales()
    {
        $this->informacion_actualizada = false;

        $this->paquete->nombre           = $this->nombre;
        $this->paquete->descripcion      = $this->descripcion;
        $this->paquete->especificaciones = $this->especificaciones;
        $this->paquete->precio           = $this->precio;

        $this->paquete->save();

        if($this->metodo == 'crear'){
            return redirect()->route('paquete', $this->paquete->id);
        }else{
            $this->informacion_actualizada = true;
        }
    }

    public function eliminar_producto(ProductoEnPaquete $producto)
    {
        $paquete_id = $producto->paquete_id;
        $producto->delete();

        $paquete       = Paquete::find($paquete_id);
        $this->paquete = $paquete;
    }

    public function eliminar_paquete()
    {
        $this->paquete->delete();
        return redirect()->route('paquetes');
    }
}

app/Http/Livewire/DetalleDeRequerimiento.php
<?php

namespace App\Http\Livewire;

use Livewire\Component;

class DetalleDeRequerimiento extends Component
{

    public $requerimiento;

    public function mount($requerimiento){
        $this->requerimiento = $requerimiento;
    }

    public function render()
    {
        return view('livewire.detalle-de-requerimiento');
    }
}

app/Http/Livewire/EtapaDeRequerimiento.php
<?php

namespace App\Http\Livewire;

use Livewire\Component;
use Validator;

class EtapaDeRequerimiento extends Component
{

    public $etapa_id;
    public $requerimiento;
    public $actualizado = false;

    public function mount($requerimiento){
        $this->requerimiento = $requerimiento;
        $this->etapa_id = $this->requerimiento->etapa_id;
    }

    public function render()
    {
        return view('livewire.etapa-de-requerimiento');
    }

    public function actualizar_etapa(){

        $validate = Validator::make([
            'etapa_id' => $this->etapa_id
        ],[

            'etapa_id' => 'required|in:1,2,3,4'

        ], [

            'etapa.required' => 'Por favor selecciona la etapa del requerimiento.',
            'etapa.in' => 'La etapa seleccionada no es válida.'

        ]);

        $this->requerimiento->etapa_id = $this->etapa_id;
        $this->requerimiento->save();

        $this->actualizado = true;

    }

}

app/Http/Livewire/FormularioDeRequerimiento.php
<?php

namespace App\Http\Livewire;

use Validator;
use App\Models\Paquete;
use Livewire\Component;
use App\Models\Requerimiento;
use App\Mail\NuevoRequerimiento;
use Illuminate\Support\Facades\Mail;
use App\Mail\GraciasPorTuRequerimiento;

class FormularioDeRequerimiento extends Component
{

    public $nombre = '';
    public $apellido = '';
    public $email = '';
    public $direccion = '';
    public $telefono = '';
    public $celular = '';
    public $paquete_id = '';

    public $requerimiento_enviado = false;

    public function render()
    {

        $paquetes = Paquete::get();

        return view('livewire.formulario-de-requerimiento', compact('paquetes'));
    }


    public function enviar_requerimiento(){

        $validar_datos = Validator::make([

            'nombre' => $this->nombre,
            'apellido' => $this->apellido,
            'email' => $this->email,
            'direccion' => $this->direccion,
            'telefono' => $this->telefono,
            'celular' => $this->celular,
            'paquete_id' => $this->paquete_id,

        ], [

            'nombre' => 'required|string',
            'apellido' => 'required|string',
            'email' => 'required|email',
            'direccion' => 'required|string',
            'telefono' => 'nullable|string',
            'celular' => 'required|string',
            'paquete_id' => 'required|exists:paquetes,id'

        ], [

            'nombre.required' => 'Por favor ingresa tu nombre',
            'apellido.required' => 'Por favor ingresa tu apellido',
            'email.required' => 'Por favor ingresa tu correo electrónico',
            'email.email' => 'Por favor ingresa un correo electrónico válido',
            'direccion.required' => 'Por favor ingresa tu dirección',
            'celular.required' => 'Por favor ingresa un número de celular',
            'paquete_id.required' => 'Por favor selecciona un paquete',
            'paquete_id.exists' => 'El paquete seleccionado no es válido',

        ])->validate();

        $requerimiento = $this->guardar_requerimiento();

        $this->enviar_notificaciones($requerimiento);

        $this->restaurar_campos();
    
    }

    public function guardar_requerimiento(){

        $requerimiento = new Requerimiento();
        $requerimiento->nombre = $this->nombre;
        $requerimiento->apellido = $this->apellido;
        $requerimiento->email = $this->email;
        $requerimiento->direccion = $this->direccion;
        $requerimiento->telefono = $this->telefono;
        $requerimiento->celular = $this->celular;
        $requerimiento->paquete_id = $this->paquete_id;

        $requerimiento->save();

        return $requerimiento;

    }

    public function enviar_notificaciones($requerimiento){

        $datos_de_mail = [

            'requerimiento' => $requerimiento

        ];

        Mail::to($requerimiento->email)
            ->send(new GraciasPorTuRequerimiento($datos_de_mail));

        Mail::to('admin@haztelapruebarapida.com')
            ->send(new NuevoRequerimiento($datos_de_mail));

    }

    public function restaurar_campos(){

        $this->nombre = '';
        $this->apellido = '';
        $this->email = '';
        $this->direccion = '';
        $this->telefono = '';
        $this->celular = '';
        $this->paquete_id = '';

        $this->requerimiento_enviado = true;

        $this->resetErrorBag();

    }

}

app/Http/Livewire/TablaDePaquetes.php
<?php

namespace App\Http\Livewire;

use App\Models\Paquete;
use Livewire\Component;

class TablaDePaquetes extends Component
{

    public function render()
    {

        $paquetes = Paquete::get();

        return view('livewire.tabla-de-paquetes', compact('paquetes'));
    }
}

app/Http/Livewire/TablaDeRequerimientos.php
<?php

namespace App\Http\Livewire;

use Livewire\Component;
use App\Models\Requerimiento;

class TablaDeRequerimientos extends Component
{

    public function render()
    {

        $requerimientos = Requerimiento::orderBy('created_at', 'desc')->get();

        return view('livewire.tabla-de-requerimientos', compact('requerimientos'));
    }
}

resources/views/livewire/agregar-producto-a-paquete.blade.php
<div>

    @if(!$mostrar_formulario)
        <a href="#" class="bg-gray-600 text-white hover:text-white px-2" wire:click.prevent="agregar_producto">
            Agregar producto
        </a>
    @else
        <form action="" wire:submit.prevent="guardar_producto_en_paquete">
            <input type="text" class="input" wire:model="cantidad" placeholder="Cantidad">
            <select name="" id="" class="input my-2" wire:model="producto_id">
                <option disabled selected value="">Elige un producto</option>
                @foreach($productos as $producto)

                <option value="{{ $producto->id }}">{{ $producto->nombre }}</option>

                @endforeach
            </select>
            <div class="flex items-center">
                <button type="submit" class="bg-blue-600 hover:bg-blue-700 text-white px-2 mr-2">Agregar</button>
                <a href="#" class="bg-gray-600 text-white hover:text-white px-2" wire:click.prevent="cancelar">Cancelar</a>
            </div>
        </form>
    @endif
</div>

resources/views/livewire/comentario-al-cliente.blade.php
<div>
    <form action="" class="py-2" wire:submit.prevent="enviar_correo_al_cliente">

        <textarea placeholder="Escribe tu comentario aquí..." wire:model.defer="comentario" name="" id="" rows="3" class="input"></textarea>
        
        @if($comentario_enviado)
        <p class="mb-2 text-sm">Se ha enviado el comentario a {{ $requerimiento->nombre_completo }}</p>
        @endif

        <button type="submit" wire:loading.attr="disabled" class="bg-blue-700 disabled:opacity-50 text-white px-2 mt-2">Enviar comentario</button>

    </form>
</div>

resources/views/livewire/detalle-de-paquete.blade.php
<div>
    <form action="" wire:submit.prevent="actualizar_detalles_generales">
        <p><b>Detalles generales</b></p>
        <table class="table w-full text-left mb-12">
            <tr>
                <th width="15%">Nombre:</th>
                <td class="py-1">
                    <input type="text" wire:model.defer="nombre" class="input">
                </td>
            </tr>
            <tr>
                <th width="15%">Descripción:</th>
                <td class="py-1">
                    <input type="text" wire:model.defer="descripcion" class="input">
                </td>
            </tr>
            <tr>
                <th width="15%">Especificaciones:</th>
                <td class="py-1">
                    <input type="text" wire:model.defer="especificaciones" class="input">
                </td>
            </tr>
            <tr>
                <th width="15%">Precio en dólares:</th>
                <td class="py-1">
                    <input type="text" wire:model.defer="precio" class="input">
                </td>
            </tr>
            <tr>
                <td></td>
                <td>
                    @if($informacion_actualizada)
                    <p class="text-green-700">La información ha sido actualizada</p>
                    @endif
                    <button type="submit" class="bg-blue-600 text-white px-2">Guardar</button>
                </td>
            </tr>
        </table>
    </form>
    @if($metodo == 'actualizar')
    <p><b>Contenido del paquete</b></p>
    <table class="table w-full text-left mb-12">
        <tr>
            <td class="py-1">
                @foreach($this->productos as $producto)
                <p>
                    ({{ $producto->cantidad }}) {{ $producto->nombre }}
                    <a href="#" class="text-red-500" wire:click.prevent="eliminar_producto({{$producto->id}})">(Eliminar)</a>
                </p>
                @endforeach
                <div>
                    @livewire('agregar-producto-a-paquete', [
                    'paquete' => $paquete
                    ])
                </div>
            </td>
        </tr>
    </table>
    <p><b>Eliminar paquete</b></p>
    <form action="" wire:submit.prevent="eliminar_paquete">
        <button type="submit" class="bg-red-600 text-white px-2" >Eliminar paquete</button>
    </form>
    @endif
</div>

resources/views/livewire/detalle-de-requerimiento.blade.php
<div>

    <h1 class="text-xl font-bold mb-7 uppercase">Detalles de requerimiento</h1>

    <table class="table w-full text-left">

        <tbody>
            <tr>
                <th width="15%">Número:</th>
                <th class="font-bold text-red-500">{{ $requerimiento->numero }}</th>
            </tr>
            <tr>
                <th>Fecha:</th>
                <td>{{ $requerimiento->fecha }}</td>
            </tr>
            <tr>
                <th>Nombre completo:</th>
                <td>{{ $requerimiento->nombre_completo }}</td>
            </tr>
            <tr>
                <th>E-mail:</th>
                <td>{{ $requerimiento->email }}</td>
            </tr>
            <tr>
                <th>Teléfono:</th>
                <td>{{ $requerimiento->telefono }}</td>
            </tr>
            <tr>
                <th>Celular:</th>
                <td>{{ $requerimiento->celular }}</td>
            </tr>
            <tr>
                <th>Dirección:</th>
                <td>{{ $requerimiento->direccion }}</td>
            </tr>
            <tr>
                <th>Paquete:</th>
                <td>{{ $requerimiento->paquete->nombre }}</td>
            </tr>
            <tr>
                <th>Precio:</th>
                <td>${{ number_format($requerimiento->paquete->precio, 2) }} dls</td>
            </tr>
            <tr>
                <th>Etapa:</th>
                <td class="py-2">
                    @livewire('etapa-de-requerimiento', [
                        'requerimiento' => $requerimiento    
                    ])
                </td>
            </tr>
            <tr>
                <th>Comentario al cliente:</th>
                <td>
                    @livewire('comentario-al-cliente', [
                        'requerimiento' => $requerimiento    
                    ])
                </td>
            </tr>
        </tbody>

    </table>
</div>

resources/views/livewire/etapa-de-requerimiento.blade.php
<div>
    <form action="" wire:submit.prevent="actualizar_etapa">
        <select name="" id="" wire:model="etapa_id" class="input">
            <option value="1">Pendiente</option>
            <option value="2">En proceso</option>
            <option value="3">Cerrado Perdido</option>
            <option value="4">Cerrado Ganado</option>
        </select>
        <button type="submit" class="bg-gray-500 px-2 text-white shadow-none outline-none mt-2">
            Actualizar
        </button>
        @if($this->actualizado)
            <p class="text-sm mt-2">La etapa del requerimiento ha sido actualizada.</p>
        @endif
    </form>
</div>

resources/views/livewire/formulario-de-requerimiento.blade.php
<div class="bg-white text-left p-5 md:py-10 md:px-12 rounded-xl shadow-lg">
    <h4 class="text-2xl font-bold uppercase text-center mb-5 text-blue-900">¡Solicita tus pruebas hoy mismo!</h4>
                        
    <form action="" class="mt-6" wire:submit.prevent="enviar_requerimiento">

        @if($requerimiento_enviado)

            <p class="text-lg text-green-600 font-bold mb-7 text-center">
                Gracias por tu requerimiento, nos pondremos en contacto contigo en la brevedad posible.
            </p>

        @endif

        <div class="flex items-center space-x-7">
            <div class="form-group w-1/2">
                <label for="" required><span class="text-red-500">*</span>Nombre:</label>
                <input type="text" wire:model.defer="nombre" class="form-control" required>
                @if($errors->has('nombre'))
                    <span class="text-red-500 mt-2 font-bold text-sm">{{ $errors->first('nombre') }}</span>
                @endif
            </div>
            <div class="form-group w-1/2">
                <label for=""><span class="text-red-500">*</span>Apellido:</label>
                <input type="text" wire:model.defer="apellido" class="form-control" required>
                @if($errors->has('apellido'))
                    <span class="text-red-500 mt-2 font-bold text-sm">{{ $errors->first('apellido') }}</span>
                @endif
            </div>
        </div>

        <div class="form-group">
            <label for=""><span class="text-red-500">*</span>Correo electrónico:</label>
            <input type="email" wire:model.defer="email" class="form-control" required>
            @if($errors->has('email'))
                <span class="text-red-500 mt-2 font-bold text-sm">{{ $errors->first('email') }}</span>
            @endif
        </div>

        <div class="form-group">
            <label for=""><span class="text-red-500">*</span>Dirección:</label>
            <input type="text" wire:model.defer="direccion" class="form-control" required>
            @if($errors->has('direccion'))
                <span class="text-red-500 mt-2 font-bold text-sm">{{ $errors->first('direccion') }}</span>
            @endif
        </div>

        <div class="flex items-center space-x-7">
            <div class="form-group w-1/2">
                <label for="">Teléfono:</label>
                <input type="text" wire:model.defer="telefono" class="form-control">
                @if($errors->has('telefono'))
                    <span class="text-red-500 mt-2 font-bold text-sm">{{ $errors->first('telefono') }}</span>
                @endif
            </div>
            <div class="form-group w-1/2">
                <label for=""><span class="text-red-500">*</span>Celular:</label>
                <input type="text" wire:model.defer="celular" class="form-control" required>
                @if($errors->has('celular'))
                    <span class="text-red-500 mt-2 font-bold text-sm">{{ $errors->first('celular') }}</span>
                @endif
            </div>
        </div>

        <div class="form-group">
            <label for=""><span class="text-red-500">*</span>Paquete:</label>
            <select name="paquete_id" class="form-control" wire:model.defer="paquete_id" required>
                <option disabled selected value="">Elige un paquete</option>
                @foreach($paquetes as $paquete)

                <option value="{{ $paquete->id }}">{{ $paquete->nombre }} | {{ $paquete->formato_de_precio }}</option>
                
                @endforeach
            </select>
            @if($errors->has('paquete_id'))
                <span class="text-red-500 mt-2 font-bold text-sm">{{ $errors->first('paquete_id') }}</span>
            @endif
        </div>

        <button type="submit" 
            class="submit-btn">
            Enviar requerimiento
        </button>

    </form>
</div>

resources/views/livewire/tabla-de-paquetes.blade.php
<div>
    @if(count($paquetes))
    <table class="table w-full text-left">
        <thead>
            <tr>
                <th>Nombre</th>
                <th>Descripción</th>
                <th>Especificaciones</th>
                <th>Contenido</th>
                <th>Precio</th>
                <th class="text-right">Ver</th>
            </tr>
        </thead>
        <tbody>
            @foreach($paquetes as $paquete)
            <tr>
                <td>{{ $paquete->nombre }}</td>
                <td>{{ $paquete->descripcion }}</td>
                <td>{{ $paquete->especificaciones }}</td>
                <td>
                    @foreach($paquete->productos as $producto)

                    <p>({{ $producto->cantidad }}) - {{ $producto->nombre }}</p>

                    @endforeach
                </td>
                <td>{{ $paquete->precio }}</td>
                <td class="text-right">
                    <a href="{{ route('paquete', $paquete) }}">Ver detalles</a>
                </td>
            </tr>
            @endforeach
        </tbody>
    </table>
    @else
    No se ha agregado paquetes.
    @endif
</div>

resources/views/livewire/tabla-de-requerimientos.blade.php
<div>
    <h1 class="text-xl font-bold mb-7 uppercase">Requerimientos</h1>

    @if(count($requerimientos))
    <table class="table text-left w-full">
        <thead>
            <tr>
                <th>Número</th>
                <th>Fecha</th>
                <th>Nombre completo</th>
                <th>E-mail</th>
                <th>Dirección</th>
                <th>Teléfono</th>
                <th>Celular</th>
                <th>Paquete</th>
                <th>Etapa</th>
                <th class="text-right">Ver</th>
            </tr>
        </thead>

        <tbody>
            @foreach($requerimientos as $requerimiento)
            <tr>
                <td>
                    <a class="font-bold text-red-500 hover:text-red-600" href="{{ route('requerimiento', $requerimiento) }}">
                    {{ $requerimiento->numero }}
                    </a>
                </td>
                <td>{{ $requerimiento->fecha }}</td>
                <td>{{ $requerimiento->nombre_completo }}</td>
                <td>{{ $requerimiento->email }}</td>
                <td>{{ $requerimiento->direccion }}</td>
                <td>{{ $requerimiento->telefono }}</td>
                <td>{{ $requerimiento->celular }}</td>
                <td>{{ $requerimiento->paquete->nombre }}</td>
                <td>{{ $requerimiento->etapa }}</td>
                <td class="text-right">
                    <a href="{{ route('requerimiento', $requerimiento->id) }}">Ver detalles</a>
                </td>
            </tr>
            @endforeach
        </tbody>
    </table>
    @else
    No hay requerimientos por el momento.
    @endif
</div>